IF EXISTS (SELECT * FROM dbo.SysObjects WHERE id = object_id(N'dbo.AUDIT_upd_IdentityInvoice') AND OBJECTPROPERTY(id, N'IsTrigger') = 1) DROP TRIGGER dbo.AUDIT_upd_IdentityInvoice 
GO
CREATE TRIGGER [dbo].[AUDIT_upd_IdentityInvoice]
ON [dbo].[IdentityInvoice] FOR UPDATE NOT FOR REPLICATION AS
BEGIN
	

	DECLARE 
		@IDENTITY_SAVE			varchar(50),
		@AUDIT_LOG_TRANSACTION_ID	Int,
		@PRIM_KEY			nvarchar(4000),
		@Inserted	    		bit,
 		@ROWS_COUNT				int,
		@FK_UserIdNumber INT,
		@FK_CashBox INT,
		@ProgramPart SMALLINT,
		@TerminalName VARCHAR(50),
		@SystemDateStr VARCHAR(8),
		@SystemDateTime DATETIME

	SET NOCOUNT ON

	Select @ROWS_COUNT=count(*) from inserted
	SET @IDENTITY_SAVE = CAST(IsNull(@@IDENTITY,1) AS varchar(50))

    SELECT TOP 1 @FK_UserIdNumber = FK_UserIdNumber,
	@FK_CashBox = FK_CashBox,
	@ProgramPart = ProgramPart,
	@TerminalName = TerminalName
	FROM PersonnelLogInfo WITH (NOLOCK)
	WHERE spid = @@spid 
	ORDER BY CreateDate DESC

	IF ISNULL(@FK_UserIdNumber, 0) = 0
	  SET @FK_UserIdNumber = 1
	IF ISNULL(@FK_CashBox, -1) <= 0
	  SET @FK_CashBox = -1
	IF ISNULL(@ProgramPart, -1) <= 0
	  SET @ProgramPart = 14 -- ppUnknown from SystemAll
	IF ISNULL(@TerminalName, '') = ''
	  SET @TerminalName = 'Unknown'

    SELECT @SystemDateStr = SystemDate FROM System WITH (NOLOCK) WHERE Number = 1
    SET @SystemDateTime = CONVERT(DATETIME, @SystemDateStr + ' ' + CONVERT(CHAR(8), CURRENT_TIMESTAMP, 108))

	INSERT INTO dbo.AUDIT_LOG_TRANSACTIONS
	(
		TABLE_NAME,
		TABLE_SCHEMA,
		AUDIT_ACTION_ID,
		HOST_NAME,
		APP_NAME,
		MODIFIED_BY,
		MODIFIED_DATE,
		AFFECTED_ROWS,
		FK_UserIdNumber,
		FK_CashBox,
		ProgramPart,
		TerminalName,
		RealDateTime
	)
	values(
		'IdentityInvoice',
		'dbo',
		1,	--	ACTION ID For UPDATE
		CASE 
		  WHEN LEN(HOST_NAME()) < 1 THEN ' '
		  ELSE HOST_NAME()
		END,
		CASE 
		  WHEN LEN(APP_NAME()) < 1 THEN ' '
		  ELSE APP_NAME()
		END,
		SUSER_SNAME(),
		@SystemDateTime,
		@ROWS_COUNT,
		@FK_UserIdNumber,
		@FK_CashBox,
		@ProgramPart,
		@TerminalName,
		GETDATE()
	)	
	
	Set @AUDIT_LOG_TRANSACTION_ID = SCOPE_IDENTITY()
	
	SET @Inserted = 0
	
	If UPDATE([DbTableName])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1, KEY2, KEY3
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[DbTableName]=N'''+replace(CONVERT(nvarchar(4000), IsNull(OLD.[DbTableName], NEW.[DbTableName]), 0),'''' ,'''''')+'''', '[DbTableName] Is Null')+' AND '+IsNull('[HotelCustomerNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[HotelCustomerNumber], NEW.[HotelCustomerNumber]), 0), '[HotelCustomerNumber] Is Null')+' AND '+IsNull('[FkDepartment]='+CONVERT(nvarchar(4000), IsNull(OLD.[FkDepartment], NEW.[FkDepartment]), 0), '[FkDepartment] Is Null')),
		    'DbTableName',
			CONVERT(nvarchar(4000), OLD.[DbTableName], 0),
			CONVERT(nvarchar(4000), NEW.[DbTableName], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[DbTableName], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[DbTableName], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[HotelCustomerNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[HotelCustomerNumber], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[FkDepartment], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[FkDepartment], 0)))
			
		FROM deleted OLD Full Outer Join inserted NEW On
			(CONVERT(nvarchar(4000), NEW.[DbTableName], 0)=CONVERT(nvarchar(4000), OLD.[DbTableName], 0) or (NEW.[DbTableName] Is Null and OLD.[DbTableName] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[HotelCustomerNumber], 0)=CONVERT(nvarchar(4000), OLD.[HotelCustomerNumber], 0) or (NEW.[HotelCustomerNumber] Is Null and OLD.[HotelCustomerNumber] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[FkDepartment], 0)=CONVERT(nvarchar(4000), OLD.[FkDepartment], 0) or (NEW.[FkDepartment] Is Null and OLD.[FkDepartment] Is Null))
			WHERE (
			
			
				(
					NEW.[DbTableName] <>
					OLD.[DbTableName]
				) Or
			
				(
					NEW.[DbTableName] Is Null And
					OLD.[DbTableName] Is Not Null
				) Or
				(
					NEW.[DbTableName] Is Not Null And
					OLD.[DbTableName] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([HotelCustomerNumber])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1, KEY2, KEY3
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[DbTableName]=N'''+replace(CONVERT(nvarchar(4000), IsNull(OLD.[DbTableName], NEW.[DbTableName]), 0),'''' ,'''''')+'''', '[DbTableName] Is Null')+' AND '+IsNull('[HotelCustomerNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[HotelCustomerNumber], NEW.[HotelCustomerNumber]), 0), '[HotelCustomerNumber] Is Null')+' AND '+IsNull('[FkDepartment]='+CONVERT(nvarchar(4000), IsNull(OLD.[FkDepartment], NEW.[FkDepartment]), 0), '[FkDepartment] Is Null')),
		    'HotelCustomerNumber',
			CONVERT(nvarchar(4000), OLD.[HotelCustomerNumber], 0),
			CONVERT(nvarchar(4000), NEW.[HotelCustomerNumber], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[DbTableName], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[DbTableName], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[HotelCustomerNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[HotelCustomerNumber], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[FkDepartment], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[FkDepartment], 0)))
			
		FROM deleted OLD Full Outer Join inserted NEW On
			(CONVERT(nvarchar(4000), NEW.[DbTableName], 0)=CONVERT(nvarchar(4000), OLD.[DbTableName], 0) or (NEW.[DbTableName] Is Null and OLD.[DbTableName] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[HotelCustomerNumber], 0)=CONVERT(nvarchar(4000), OLD.[HotelCustomerNumber], 0) or (NEW.[HotelCustomerNumber] Is Null and OLD.[HotelCustomerNumber] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[FkDepartment], 0)=CONVERT(nvarchar(4000), OLD.[FkDepartment], 0) or (NEW.[FkDepartment] Is Null and OLD.[FkDepartment] Is Null))
			WHERE (
			
			
				(
					NEW.[HotelCustomerNumber] <>
					OLD.[HotelCustomerNumber]
				) Or
			
				(
					NEW.[HotelCustomerNumber] Is Null And
					OLD.[HotelCustomerNumber] Is Not Null
				) Or
				(
					NEW.[HotelCustomerNumber] Is Not Null And
					OLD.[HotelCustomerNumber] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([FkDepartment])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1, KEY2, KEY3
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[DbTableName]=N'''+replace(CONVERT(nvarchar(4000), IsNull(OLD.[DbTableName], NEW.[DbTableName]), 0),'''' ,'''''')+'''', '[DbTableName] Is Null')+' AND '+IsNull('[HotelCustomerNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[HotelCustomerNumber], NEW.[HotelCustomerNumber]), 0), '[HotelCustomerNumber] Is Null')+' AND '+IsNull('[FkDepartment]='+CONVERT(nvarchar(4000), IsNull(OLD.[FkDepartment], NEW.[FkDepartment]), 0), '[FkDepartment] Is Null')),
		    'FkDepartment',
			CONVERT(nvarchar(4000), OLD.[FkDepartment], 0),
			CONVERT(nvarchar(4000), NEW.[FkDepartment], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[DbTableName], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[DbTableName], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[HotelCustomerNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[HotelCustomerNumber], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[FkDepartment], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[FkDepartment], 0)))
			
		FROM deleted OLD Full Outer Join inserted NEW On
			(CONVERT(nvarchar(4000), NEW.[DbTableName], 0)=CONVERT(nvarchar(4000), OLD.[DbTableName], 0) or (NEW.[DbTableName] Is Null and OLD.[DbTableName] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[HotelCustomerNumber], 0)=CONVERT(nvarchar(4000), OLD.[HotelCustomerNumber], 0) or (NEW.[HotelCustomerNumber] Is Null and OLD.[HotelCustomerNumber] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[FkDepartment], 0)=CONVERT(nvarchar(4000), OLD.[FkDepartment], 0) or (NEW.[FkDepartment] Is Null and OLD.[FkDepartment] Is Null))
			WHERE (
			
			
				(
					NEW.[FkDepartment] <>
					OLD.[FkDepartment]
				) Or
			
				(
					NEW.[FkDepartment] Is Null And
					OLD.[FkDepartment] Is Not Null
				) Or
				(
					NEW.[FkDepartment] Is Not Null And
					OLD.[FkDepartment] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([IdentityField])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1, KEY2, KEY3
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[DbTableName]=N'''+replace(CONVERT(nvarchar(4000), IsNull(OLD.[DbTableName], NEW.[DbTableName]), 0),'''' ,'''''')+'''', '[DbTableName] Is Null')+' AND '+IsNull('[HotelCustomerNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[HotelCustomerNumber], NEW.[HotelCustomerNumber]), 0), '[HotelCustomerNumber] Is Null')+' AND '+IsNull('[FkDepartment]='+CONVERT(nvarchar(4000), IsNull(OLD.[FkDepartment], NEW.[FkDepartment]), 0), '[FkDepartment] Is Null')),
		    'IdentityField',
			CONVERT(nvarchar(4000), OLD.[IdentityField], 0),
			CONVERT(nvarchar(4000), NEW.[IdentityField], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[DbTableName], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[DbTableName], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[HotelCustomerNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[HotelCustomerNumber], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[FkDepartment], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[FkDepartment], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[DbTableName], 0)=CONVERT(nvarchar(4000), OLD.[DbTableName], 0) or (NEW.[DbTableName] Is Null and OLD.[DbTableName] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[HotelCustomerNumber], 0)=CONVERT(nvarchar(4000), OLD.[HotelCustomerNumber], 0) or (NEW.[HotelCustomerNumber] Is Null and OLD.[HotelCustomerNumber] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[FkDepartment], 0)=CONVERT(nvarchar(4000), OLD.[FkDepartment], 0) or (NEW.[FkDepartment] Is Null and OLD.[FkDepartment] Is Null))
			where (
			
			
				(
					NEW.[IdentityField] <>
					OLD.[IdentityField]
				) Or
			
				(
					NEW.[IdentityField] Is Null And
					OLD.[IdentityField] Is Not Null
				) Or
				(
					NEW.[IdentityField] Is Not Null And
					OLD.[IdentityField] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	-- Watch
	
	-- Lookup
	
	IF @Inserted = 0
	BEGIN
		DELETE FROM dbo.AUDIT_LOG_TRANSACTIONS WHERE AUDIT_LOG_TRANSACTION_ID = @AUDIT_LOG_TRANSACTION_ID
	END
	-- Restore @@IDENTITY Value  
    DECLARE @maxprec AS varchar(2)
    SET @maxprec=CAST(@@MAX_PRECISION as varchar(2))
    EXEC('SELECT IDENTITY(decimal('+@maxprec+',0),'+@IDENTITY_SAVE+',1) id INTO #tmp')
End
